/*
 * ExactMatchingAutomaton.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_MATCHING_AUTOMATON_H__
#define _EXACT_MATCHING_AUTOMATON_H__

#include <automaton/Automaton.h>
#include <automaton/FSM/NFA.h>
#include <string/LinearString.h>
#include <string/String.h>

namespace stringology {

namespace exact {

class ExactMatchingAutomaton : public string::VisitableStringBase::const_visitor_type {
public:
	ExactMatchingAutomaton() {}

	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct(const string::String& pattern);

	static automaton::NFA construct(const string::LinearString& pattern);
private:
	void Visit(void*, const string::Epsilon& pattern) const;
	void Visit(void*, const string::LinearString& pattern) const;
	void Visit(void*, const string::CyclicString& pattern) const;

	static const ExactMatchingAutomaton EXACT_MATCHING_AUTOMATON;
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_MATCHING_AUTOMATON_H__ */
